Attribute VB_Name = "Module1"

Public Declare Function GetCurrentProcessId Lib "kernel32" () As Long
Public Declare Function GetProcessMemoryInfo Lib "PSAPI.DLL" (ByVal hProcess As Long, ppsmemCounters As PROCESS_MEMORY_COUNTERS, ByVal cb As Long) As Long
Public Declare Function Process32First Lib "kernel32" (ByVal hSnapshot As Long, lppe As PROCESSENTRY32) As Long
Public Declare Function Process32Next Lib "kernel32" (ByVal hSnapshot As Long, lppe As PROCESSENTRY32) As Long
Public Declare Function CloseHandle Lib "Kernel32.dll" (ByVal Handle As Long) As Long
Public Declare Function OpenProcess Lib "Kernel32.dll" (ByVal dwDesiredAccessas As Long, ByVal bInheritHandle As Long, ByVal dwProcId As Long) As Long
Public Declare Function EnumProcesses Lib "PSAPI.DLL" (ByRef lpidProcess As Long, ByVal cb As Long, ByRef cbNeeded As Long) As Long
Public Declare Function GetModuleFileNameExA Lib "PSAPI.DLL" (ByVal hProcess As Long, ByVal hModule As Long, ByVal ModuleName As String, ByVal nSize As Long) As Long
Public Declare Function EnumProcessModules Lib "PSAPI.DLL" (ByVal hProcess As Long, ByRef lphModule As Long, ByVal cb As Long, ByRef cbNeeded As Long) As Long
Public Declare Function CreateToolhelp32Snapshot Lib "kernel32" (ByVal dwFlags As Long, ByVal th32ProcessID As Long) As Long
Public Declare Function GetVersionExA Lib "kernel32" (lpVersionInformation As OSVERSIONINFO) As Integer
Public Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Public Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
Public Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYSTATUS)



Public Const PROCESS_QUERY_INFORMATION = 1024
Public Const PROCESS_VM_READ = 16
Public Const MAX_PATH = 260
Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const SYNCHRONIZE = &H100000
Public Const PROCESS_ALL_ACCESS = &H1F0FFF
Public Const TH32CS_SNAPPROCESS = &H2&
Public Const hNull = 0
Public Const WIN95_System_Found = 1
Public Const WINNT_System_Found = 2
Public Const Default_Log_Size = 10000000
Public Const Default_Log_Days = 0
Public Const SPECIFIC_RIGHTS_ALL = &HFFFF
Public Const STANDARD_RIGHTS_ALL = &H1F0000


Type MEMORYSTATUS
    dwLength As Long
    dwMemoryLoad As Long
    dwTotalPhys As Long
    dwAvailPhys As Long
    dwTotalPageFile As Long
    dwAvailPageFile As Long
    dwTotalVirtual As Long
    dwAvailVirtual As Long
End Type


Type PROCESS_MEMORY_COUNTERS
    cb As Long
    PageFaultCount As Long
    PeakWorkingSetSize As Long
    WorkingSetSize As Long
    QuotaPeakPagedPoolUsage As Long
    QuotaPagedPoolUsage As Long
    QuotaPeakNonPagedPoolUsage As Long
    QuotaNonPagedPoolUsage As Long
    PagefileUsage As Long
    PeakPagefileUsage As Long
End Type


Public Type PROCESSENTRY32
    dwSize As Long
    cntUsage As Long
    th32ProcessID As Long
    th32DefaultHeapID As Long
    th32ModuleID As Long
    cntThreads As Long
    th32ParentProcessID As Long
    pcPriClassBase As Long '
    dwFlags As Long
    szExeFile As String * 260
    End Type


Public Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
 
    szCSDVersion As String * 128
End Type


Public Function GetProcesses(Optional SpecProc = False, Optional NameProc = "") As Variant

    Dim booResult As Boolean
    Dim lngLength As Long
    Dim lngProcessID As Long
    Dim strProcessName As String
    Dim lngSnapHwnd As Long
    Dim udtProcEntry As PROCESSENTRY32
    Dim lngCBSize As Long
    Dim lngCBSizeReturned As Long
    Dim lngNumElements As Long
    Dim lngProcessIDs() As Long
    Dim lngCBSize2 As Long
    Dim lngModules(1 To 200) As Long
    Dim lngReturn As Long
    Dim strModuleName As String
    Dim lngSize As Long
    Dim lngHwndProcess As Long
    Dim lngLoop As Long
    Dim b As Long
    Dim c As Long
    Dim e As Long
    Dim d As Long
    Dim count As Long: count = 0
    Dim pmc As PROCESS_MEMORY_COUNTERS
    Dim lret As Long
    Dim strProcName2 As String
    Dim strProcName As String
    Dim arr As Variant
    Dim ArrFin As Variant
    
    On Error GoTo Error_handler

   booResult = False


     

    Select Case getVersion()
          Case WIN95_System_Found

        Case WINNT_System_Found

            lngCBSize = 8
            lngCBSizeReturned = 96

            Do While lngCBSize <= lngCBSizeReturned
                DoEvents
                 
                lngCBSize = lngCBSize * 2
                 
                ReDim lngProcessIDs(lngCBSize / 4) As Long
                 
                lngReturn = EnumProcesses(lngProcessIDs(1), lngCBSize, lngCBSizeReturned)
            Loop

             
            lngNumElements = lngCBSizeReturned / 4
             
            ReDim arr(lngNumElements, 4)
            For lngLoop = 1 To lngNumElements
            DoEvents

             
            lngHwndProcess = OpenProcess(PROCESS_QUERY_INFORMATION Or PROCESS_VM_READ, 0, lngProcessIDs(lngLoop))

            If lngHwndProcess <> 0 Then
                 
                lngReturn = EnumProcessModules(lngHwndProcess, lngModules(1), 200, lngCBSize2)

                 
                If lngReturn <> 0 Then

                     
                    strModuleName = Space(MAX_PATH)

                     
                    lngSize = 500

                     
                    lngReturn = GetModuleFileNameExA(lngHwndProcess, lngModules(1), strModuleName, lngSize)

                     
                    strProcessName = Left(strModuleName, lngReturn)

                     
                    strProcessName = UCase$(Trim$(strProcessName))

                    strProcName2 = GetElement(Trim(Replace(strProcessName, Chr$(0), "")), "\", 0, 0, GetNumElements(Trim(Replace(strProcessName, Chr$(0), "")), "\") - 1)

                    If (SpecProc = True And GetCurrentProcessId() = lngProcessIDs(lngLoop)) Or (SpecProc = False And NameProc = "") Or (NameProc <> "" And strProcName2 = NameProc And SpecProc = False) Then

                        
                        pmc.cb = LenB(pmc)

                           lret = GetProcessMemoryInfo(lngHwndProcess, pmc, pmc.cb)
                            
                            'Debug.Print strProcName2 & "::" & CStr(pmc.WorkingSetSize) & vbTab & (pmc.PeakWorkingSetSize) & vbTab & pmc.PagefileUsage & vbTab & pmc.QuotaPagedPoolUsage & vbTab & pmc.PeakPagefileUsage & vbTab & pmc.QuotaNonPagedPoolUsage & vbTab & pmc.QuotaPeakPagedPoolUsage
                            arr(count, 0) = strProcName2
                            arr(count, 1) = CStr(pmc.WorkingSetSize)
                            arr(count, 2) = CStr((pmc.PeakWorkingSetSize))
                            arr(count, 3) = CStr((pmc.PagefileUsage))
                            arr(count, 4) = CStr((pmc.PeakPagefileUsage))
                            
                            count = count + 1
                    End If
                End If
            End If
             
            lngReturn = CloseHandle(lngHwndProcess)
            DoEvents
        Next

    End Select

IsProcessRunning_Exit:
NLim = 0

For h = 0 To UBound(arr, 1)
 If Len(arr(h, 0)) > 0 Then
  NLim = NLim + 1
 Else
 Debug.Print
 End If
Next

ReDim ArrFin(NLim, 4)

NLim = 0
For h = 0 To UBound(arr, 1)
 If Len(arr(h, 0)) > 0 Then
  ArrFin(NLim, 0) = arr(h, 0)
  ArrFin(NLim, 1) = arr(h, 1)
  ArrFin(NLim, 2) = arr(h, 2)
  ArrFin(NLim, 3) = arr(h, 3)
  ArrFin(NLim, 4) = arr(h, 4)
    
  NLim = NLim + 1
 End If
Next

GetProcesses = ArrFin
 
Exit Function
Error_handler:
    Err.Raise Err, Err.Source, "ProcessInfo", Error
    Resume Next
End Function


Private Function getVersion() As Long

    Dim osinfo As OSVERSIONINFO
    Dim retvalue As Integer

    osinfo.dwOSVersionInfoSize = 148
    osinfo.szCSDVersion = Space$(128)
    retvalue = GetVersionExA(osinfo)
    getVersion = osinfo.dwPlatformId

End Function


Private Function StrZToStr(s As String) As String
    StrZToStr = Left$(s, Len(s) - 1)
End Function



Public Function GetElement(ByVal strList As String, ByVal strDelimiter As String, ByVal lngNumColumns As Long, ByVal lngRow As Long, ByVal lngColumn As Long) As String

    Dim lngCounter As Long

     
    strList = strList & strDelimiter

    lngColumn = IIf(lngRow = 0, lngColumn, (lngRow * lngNumColumns) + lngColumn)

    For lngCounter = 0 To lngColumn - 1

   
        strList = Mid$(strList, InStr(strList, strDelimiter) + Len(strDelimiter), Len(strList))

        If Len(strList) = 0 Then
            GetElement = ""
            Exit Function
        End If

    Next lngCounter
 
    GetElement = Left$(strList, InStr(strList, strDelimiter) - 1)

End Function



Public Function GetNumElements(ByVal strList As String, ByVal strDelimiter As String) As Integer

    Dim intElementCount As Integer

     
    If Len(strList) = 0 Then
        GetNumElements = 0
        Exit Function
    End If

    
    strList = strList & strDelimiter
 
    While InStr(strList, strDelimiter) > 0
        intElementCount = intElementCount + 1
        strList = Mid$(strList, InStr(strList, strDelimiter) + 1, Len(strList))
    Wend

     
    GetNumElements = intElementCount

End Function

Function MaxMemAvailable()
 Dim MemStat As MEMORYSTATUS
   
    GlobalMemoryStatus MemStat
 MaxMemAvailable = MemStat.dwTotalPageFile
End Function

Function MaxMemPhisique()
 Dim MemStat As MEMORYSTATUS
   
    GlobalMemoryStatus MemStat
 MaxMemPhisique = MemStat.dwTotalPhys
End Function
