VERSION 5.00
Begin VB.UserControl VUMeter 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.CommandButton Command2 
      Caption         =   "-"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   2520
      TabIndex        =   2
      Top             =   360
      Width           =   255
   End
   Begin VB.CommandButton Command1 
      Caption         =   "+"
      Height          =   255
      Left            =   2520
      TabIndex        =   1
      Top             =   120
      Width           =   255
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00000000&
      Height          =   975
      Left            =   0
      ScaleHeight     =   915
      ScaleWidth      =   2400
      TabIndex        =   0
      Top             =   0
      Width           =   2465
      Begin VB.Line LineS 
         BorderColor     =   &H00FFC0C0&
         X1              =   0
         X2              =   0
         Y1              =   0
         Y2              =   960
      End
      Begin VB.Line LineP 
         BorderColor     =   &H000000FF&
         Visible         =   0   'False
         X1              =   0
         X2              =   2400
         Y1              =   940
         Y2              =   940
      End
      Begin VB.Line Line8 
         BorderColor     =   &H00404040&
         X1              =   0
         X2              =   3360
         Y1              =   840
         Y2              =   840
      End
      Begin VB.Line Line7 
         BorderColor     =   &H00404040&
         X1              =   0
         X2              =   3360
         Y1              =   720
         Y2              =   720
      End
      Begin VB.Line Line6 
         BorderColor     =   &H00404040&
         X1              =   0
         X2              =   3360
         Y1              =   600
         Y2              =   600
      End
      Begin VB.Line Line5 
         BorderColor     =   &H00404040&
         X1              =   0
         X2              =   3360
         Y1              =   480
         Y2              =   480
      End
      Begin VB.Line Line4 
         BorderColor     =   &H00404040&
         X1              =   0
         X2              =   3360
         Y1              =   360
         Y2              =   360
      End
      Begin VB.Line Line3 
         BorderColor     =   &H00404040&
         X1              =   0
         X2              =   3360
         Y1              =   120
         Y2              =   120
      End
      Begin VB.Line Line2 
         BorderColor     =   &H00404040&
         X1              =   0
         X2              =   3360
         Y1              =   240
         Y2              =   240
      End
      Begin VB.Line Line1 
         BorderColor     =   &H0000FF00&
         Index           =   0
         Visible         =   0   'False
         X1              =   0
         X2              =   15
         Y1              =   940
         Y2              =   940
      End
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   960
      Width           =   2415
   End
   Begin VB.Label Label1 
      Caption         =   "8x"
      Height          =   255
      Left            =   2520
      TabIndex        =   3
      Top             =   720
      Width           =   495
   End
End
Attribute VB_Name = "VUMeter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private points(60) As Variant
Private Zoom As Integer
Private TSheet
Private TPicco
Private PosS

Public Sub Plot()
On Error Resume Next
For Y = 0 To 59
 Line1(Y).Y1 = Line1(0).Y2 - (points(Y) * Zoom) * Line1(0).Y2
 Line1(Y).Y2 = Line1(0).Y2
 If Y <> 0 Then Line1(Y).Visible = True

Next
 If PosS > -1 Then
  PosS = (PosS + 1) Mod 60
  LineS.X1 = Line1(60 - PosS).X1
  LineS.X2 = Line1(60 - PosS).X2
  If PosS = 0 Then
    LineS.Visible = False
  Else
    LineS.Visible = True
  End If
  
 End If
End Sub

Private Sub Command1_Click()
Zoom = (Zoom * 2)
If Zoom > 1024 Then Zoom = 1024
Label1.Caption = Zoom & "x"
End Sub


Private Sub Command2_Click()
Zoom = Zoom / 2
If Zoom < 1 Then Zoom = 1
Label1.Caption = Zoom & "x"
End Sub

Private Sub UserControl_Initialize()
Zoom = 8
Init
End Sub

Sub Init()
Y = 1
For X = 40 To 2399 Step 40
 Load Line1(Y)
 Line1(Y).X1 = X
 Line1(Y).X2 = X
 Line1(Y).Y1 = Line1(0).Y1
 Line1(Y).Y2 = Line1(0).Y2
 Line1(Y).Visible = True
 Y = Y + 1
Next
Clear
End Sub

Public Sub Clear()
For t = 0 To 59
 points(t) = 0
Next
PosS = -1
Plot
LineP.Visible = False
Label2.Caption = ""
LineS.Visible = False
End Sub

Public Property Get pPoints()

pPoints = points

End Property

Public Property Let pPoints(ByVal vNewValue As Variant)
For t = 0 To UBound(vNewValue, 1) - 1
 points(t) = vNewValue(t)
 If Len(points(t)) = 0 Then points(t) = 0
Next

End Property

Public Property Get TimeSheet() As Variant
TimeSheet = TSheet
End Property

Public Property Let TimeSheet(ByVal vNewValue As Variant)
TSheet = vNewValue
Label2.Caption = TSheet & " sec."
End Property


Public Property Get Picco() As Variant
Picco = TPicco
End Property

Public Property Let Picco(ByVal vNewValue As Variant)
On Error Resume Next
TPicco = vNewValue
LineP.Y1 = Line1(0).Y2 - (TPicco * Zoom) * Line1(0).Y2
LineP.Y2 = LineP.Y1
LineP.Visible = True
End Property

Public Function StartBar()
PosS = 0
End Function
